import pandas as pd
import numpy as np
import math
import sklearn
import matplotlib.pyplot as plt
#import seaborn as sns

tdata=pd.read_csv("Data/Transaction.csv" )
cdata=pd.read_csv("Data/Customer.csv")
filtered_data=tdata[['CustomerID','Date']].drop_duplicates()
filtered_data.Date.value_counts()[:10].plot(kind='bar')
cus01=tdata[tdata.Date=='1/6/21']
# cus01.info()
# cus01.describe()
cus01=cus01[['CustomerID','InvoiceNo','ItemCode','QTY.']]
tdata.shape
tdata = tdata.loc[tdata['QTY.'] > 0]

tdata['ItemCode'].sum()
tdata.describe()
tdata.shape
#matrix of items for customers
customer_item_matrix = tdata.pivot_table(
    index='CustomerID',
    columns='ItemCode',
    values='QTY.',
    aggfunc='sum'
)


customer_item_matrix
customer_item_matrix = customer_item_matrix.applymap(lambda x: 1 if x > 0 else 0)
customer_item_matrix

from sklearn.metrics.pairwise import cosine_similarity

#User-User similarity matrix creating using cosine similarity
user_user_sim_matrix = pd.DataFrame(
    cosine_similarity(customer_item_matrix)
)


user_user_sim_matrix.columns = customer_item_matrix.index
user_user_sim_matrix['CustomerID'] = customer_item_matrix.index
user_user_sim_matrix = user_user_sim_matrix.set_index('CustomerID')

user_user_sim_matrix.loc[1000].sort_values(ascending=False)
items_bought_by_A = set(customer_item_matrix.loc[1000].iloc[
    customer_item_matrix.loc[1000].to_numpy().nonzero()
].index)


ccc = len(tdata[tdata['CustomerID'] == 1037])
if ( ccc > 0 ):

    items_bought_by_B = set(customer_item_matrix.loc[1037].iloc[
        customer_item_matrix.loc[1037].to_numpy().nonzero()
    ].index)

    items_to_recommend_to_B = items_bought_by_A - items_bought_by_B
    Getrecommend = tdata.loc[ tdata['ItemCode'].isin(items_to_recommend_to_B), ['ItemCode', 'ItemName']].drop_duplicates().set_index('ItemCode')
    print(Getrecommend)





