
import pandas as pd
import seaborn as sns
import numpy as np
import matplotlib.pyplot as plt
from sklearn.linear_model import LinearRegression
from sklearn.model_selection import train_test_split

data = pd.read_csv("Data/DataSet.csv" , engine='python' , encoding = 'latin1')
data = data.drop(data.columns[[0 ,3,5,6,7]], axis=1)
data = data.dropna(axis=0, how='any', thresh=None, subset=None, inplace=False)
datas =  data.head()


data = data[(data["ItemNo"] == 106368)]

gethead = data.columns
# print(gethead)
x = data[['OrderAmount']]
y = data['UnitPrice']

x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.3, random_state=2)
lm = LinearRegression()
lm.fit(x_train, y_train)

 # Unit Price
coeff_df = pd.DataFrame(lm.coef_, x.columns, columns=['Coefficient'])
# print(coeff_df)

accuracy = lm.score(x_test, y_test)
new_input = [[1]]
pred = lm.predict(new_input)
print (int(pred))
