from datetime import datetime
from django.shortcuts import render, redirect, reverse
from django.template import loader
from django.http import HttpResponse
from User.forms import MyForm,MyForm2
from django.contrib.auth import authenticate, login
from User import models as Umodels
from django.http import HttpResponseRedirect
from django.contrib import messages

# start ML prediction #
import pandas as pd
import numpy as np
from matplotlib import  pyplot
from statsmodels.tsa.ar_model import AutoReg
from statsmodels.tsa.stattools import adfuller
from tqdm import tqdm, trange
from time import sleep
import warnings
warnings.filterwarnings("ignore")
from datetime import datetime
from django.shortcuts import render
import matplotlib.pyplot as plt
import io
import urllib, base64

import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt, mpld3
import numpy as np


# ------------------- Libraries   Customer Churn
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
import plotly.express as px
import plotly.graph_objects as go
import datetime as dt
from sklearn.metrics import accuracy_score, confusion_matrix, classification_report, f1_score
from sklearn.linear_model import LogisticRegression
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import SVC
from sklearn.tree import DecisionTreeClassifier
from xgboost import XGBClassifier
from sklearn.model_selection import train_test_split
# ------------------- Libraries   Customer Churn


# ------------------- Libraries  Customer Product Recommendation
import pandas as pd
import numpy as np
import math
import sklearn
import matplotlib.pyplot as plt
import json
#import seaborn as sns
# ------------------- Libraries   Customer Product Recommendation


# ------------------- Libraries Demand Prediction
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
plt.style.use('seaborn')
import datetime as dt
import sklearn
from sklearn.preprocessing import StandardScaler
from sklearn.cluster import KMeans
from sklearn.metrics import silhouette_score
from scipy.cluster.hierarchy import linkage
from scipy.cluster.hierarchy import dendrogram
from scipy.cluster.hierarchy import cut_tree
# ------------------- Libraries Demand Prediction

# -------------------   Expiry Prediction
import numpy as np  # linear algebra
import pandas as pd  # data processing, CSV file I/O (e.g. pd.read_csv)
import random as rd  # generating random numbers
import datetime  # manipulating date formats
import matplotlib.pyplot as plt  # basic plotting
import seaborn as sns  # for prettier plots
from statsmodels.tsa.arima_model import ARIMA
from statsmodels.tsa.statespace.sarimax import SARIMAX
from pandas.plotting import autocorrelation_plot
from statsmodels.tsa.stattools import adfuller, acf, pacf, arma_order_select_ic
import statsmodels.formula.api as smf
import statsmodels.tsa.api as smt
import statsmodels.api as sm
import scipy.stats as scs
# -------------------   Expiry Prediction


# -------------------   Basket Analysis
import numpy as np
import pandas as pd
import json
import plotly.express as px
from mlxtend.frequent_patterns import apriori
from mlxtend.frequent_patterns import association_rules
# -------------------   Basket Analysis


# -------------------   Price Prediction
import pandas as pd
import seaborn as sns
import numpy as np
import matplotlib.pyplot as plt
from sklearn.linear_model import LinearRegression
from sklearn.model_selection import train_test_split

# -------------------   Price Prediction


# Start  CompanyHome
def Homepage(request):
    return render(request, 'Admin/Homepage.html');
# End  CompanyHome

# start Customer Churn
def Customer_Churn(request):
     if request.method == 'POST':
        myForm = MyForm(request.POST)
        if myForm.is_valid():
            customerid = myForm.cleaned_data['customerid']

            transData = pd.read_csv('Data/Book1.csv', encoding='latin-1')
            transData.head(30)  # view first rows of the dataset

            transData.tail(10)  # view last rows of the dataset
            transData.describe(include='all')
            transData.shape  # view the no.of rows and no.of columns in the dataset

            transData.info()
            transData['DATE'] = pd.to_datetime(transData['DATE'])
            transData.info()
            transData.Invoice_No.nunique()  # no.of unique values in Invoice_No column

            transData.CustomerID.nunique()  # no.of unique values in CustomerID column
            ucustomer = transData.isnull().sum()  # view the missing values in the dataset
            # print(ucustomer)

            transData = transData.dropna(subset=['Invoice_No'], axis=0, how='any').reset_index(
                drop=True)  # remove rows which has missing values in Invoice_No column
            transData.isnull().sum()
            transData = transData.filter(['Invoice_No', 'CustomerID', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
            transData = transData.sort_values(by=['CustomerID']).reset_index(drop=True)
            Data = transData.groupby('CustomerID').agg(FirstPurch=('DATE', 'first'), LastPurch=('DATE', 'last'))
            transData.groupby(['CustomerID', 'DATE'])['CustomerID'].count()

            Data1 = transData.groupby("CustomerID").agg({"DATE": "nunique"}).rename(columns={'DATE': 'ActiveDays'})

            transData1 = pd.merge(Data, Data1, on='CustomerID')

            transData = transData.drop_duplicates(subset='CustomerID').reset_index(drop=True)
            transData = pd.merge(transData, transData1, on='CustomerID')
            transData['DaysFirstPurch'] = (pd.Timestamp('today') - transData['FirstPurch']).dt.days
            transData['DaysLastPurch'] = (pd.Timestamp('today') - transData['LastPurch']).dt.days
            # average time between purchases
            transData['Wavelength'] = (transData['DaysFirstPurch'] - transData['DaysLastPurch']) / transData[
                'ActiveDays']
            transData['ChurnFactor'] = transData['DaysLastPurch'] / transData['Wavelength']
            transData = transData.drop(['Invoice_No', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
            transData['CHURN'] = ' '
            # xgb_tuned = XGBClassifier()
            # xgb_tuned_gs = GridSearchCV(xgb_tuned, param_grid_xgb, cv=3, scoring='f1', n_jobs=-1, verbose=1)
            # xgb_tuned_gs.fit(X_train, y_train)

            # make predictions with the trained model on the test set
            # y_pred_xgb_tuned = xgb_tuned_gs.predict(X_test)
            # y_pred_xgb_tuned_prob = xgb_tuned_gs.predict_proba(X_test)

            transData['CHURN'] = 0
            transData.loc[((transData['Wavelength']) > 10 & (transData['ChurnFactor'] > 2)) | (
                    (transData['Wavelength']) < 10 & (transData['ChurnFactor'] > 5)), 'CHURN'] = 1



            transData = transData.filter(['CustomerID', 'CHURN'], axis=1)
            ReadFinalChurn = transData[(transData["CustomerID"] == customerid)]

# start XGB
            from numpy import loadtxt
            from xgboost import XGBClassifier
            from sklearn.model_selection import train_test_split

            # split data into X and y
            X = transData[['CustomerID']]
            Y = transData['CHURN']
            # split data into train and test sets
            seed = 7
            test_size = 0.33
            X_train, X_test, y_train, y_test = train_test_split(X, Y, test_size=test_size, random_state=seed)
            # fit model no training data
            model = XGBClassifier()
            model.fit(X_train, y_train)
            # make predictions for test data
         #   print(ReadFinalChurn)
            FinalChurn = ReadFinalChurn['CHURN'].tolist()
            print(FinalChurn)
            if (FinalChurn == [1]):
                customerType = "CHURN"
            elif(FinalChurn == []):
                customerType = "CUSTOMER NOT FOUND"
            else:
                customerType = "NON CHURN"

            form = MyForm()
            context = {'customerType': "Customer  Type is :  " + customerType  ,'form':form }
            return render(request, 'Admin/Customer_Churn.html', context)

     else:
         form = MyForm()
     return render(request, 'Admin/Customer_Churn.html', {'form':form});
# end Customer Churn



# start  Customer Churn Report
def Customer_Churn_Report(request):
    transData = pd.read_csv('Data/Book1.csv', encoding='latin-1')
    transData.head(30)  # view first rows of the dataset

    transData.tail(10)  # view last rows of the dataset
    transData.describe(include='all')
    transData.shape  # view the no.of rows and no.of columns in the dataset

    transData.info()
    transData['DATE'] = pd.to_datetime(transData['DATE'])
    transData.info()
    transData.Invoice_No.nunique()  # no.of unique values in Invoice_No column

    transData.CustomerID.nunique()  # no.of unique values in CustomerID column
    ucustomer = transData.isnull().sum()  # view the missing values in the dataset
    # print(ucustomer)

    transData = transData.dropna(subset=['Invoice_No'], axis=0, how='any').reset_index(
        drop=True)  # remove rows which has missing values in Invoice_No column
    transData.isnull().sum()
    transData = transData.filter(['Invoice_No', 'CustomerID', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
    transData = transData.sort_values(by=['CustomerID']).reset_index(drop=True)
    Data = transData.groupby('CustomerID').agg(FirstPurch=('DATE', 'first'), LastPurch=('DATE', 'last'))
    transData.groupby(['CustomerID', 'DATE'])['CustomerID'].count()

    Data1 = transData.groupby("CustomerID").agg({"DATE": "nunique"}).rename(columns={'DATE': 'ActiveDays'})

    transData1 = pd.merge(Data, Data1, on='CustomerID')

    transData = transData.drop_duplicates(subset='CustomerID').reset_index(drop=True)
    transData = pd.merge(transData, transData1, on='CustomerID')
    transData['DaysFirstPurch'] = (pd.Timestamp('today') - transData['FirstPurch']).dt.days
    transData['DaysLastPurch'] = (pd.Timestamp('today') - transData['LastPurch']).dt.days
    # average time between purchases
    transData['Wavelength'] = (transData['DaysFirstPurch'] - transData['DaysLastPurch']) / transData[
        'ActiveDays']
    transData['ChurnFactor'] = transData['DaysLastPurch'] / transData['Wavelength']
    transData = transData.drop(['Invoice_No', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
    transData['CHURN'] = ' '
    # xgb_tuned = XGBClassifier()
    # xgb_tuned_gs = GridSearchCV(xgb_tuned, param_grid_xgb, cv=3, scoring='f1', n_jobs=-1, verbose=1)
    # xgb_tuned_gs.fit(X_train, y_train)

    # make predictions with the trained model on the test set
    # y_pred_xgb_tuned = xgb_tuned_gs.predict(X_test)
    # y_pred_xgb_tuned_prob = xgb_tuned_gs.predict_proba(X_test)

    transData['CHURN'] = 0
    transData.loc[((transData['Wavelength']) > 10 & (transData['ChurnFactor'] > 2)) | (
            (transData['Wavelength']) < 10 & (transData['ChurnFactor'] > 5)), 'CHURN'] = 1

    transData = transData.loc[transData['CHURN'] == 1]

  #  transData = transData.filter(['CustomerID', 'CHURN'], axis=1)


    # start XGB
    from numpy import loadtxt
    from xgboost import XGBClassifier
    from sklearn.model_selection import train_test_split

    # split data into X and y
    X = transData[['CustomerID']]
    Y = transData['CHURN']
    # split data into train and test sets
    seed = 7
    test_size = 0.33
    X_train, X_test, y_train, y_test = train_test_split(X, Y, test_size=test_size, random_state=seed)
    # fit model no training data
    model = XGBClassifier()
    model.fit(X_train, y_train)
    # make predictions for test data
    print(transData)


  #  df = getfinal[:10]
    # data = data.to_html()
    json_records = transData.reset_index().to_json(orient='records')
    arr = []
    arr = json.loads(json_records)

    context = {'d': arr}
    return render(request, 'Admin/Customer_Churn_Report.html',context);
# end Customer Churn Report




# start Item Recommendation
def Item_Recommendation(request):
     if request.method == 'POST':
        myForm = MyForm(request.POST)
        if myForm.is_valid():
            customerid = myForm.cleaned_data['customerid']

            tdata = pd.read_csv("Data/Transaction.csv")
            cdata = pd.read_csv("Data/Customer.csv")

            filtered_data = tdata[['CustomerID', 'Date']].drop_duplicates()
            filtered_data.Date.value_counts()[:10].plot(kind='bar')
            cus01 = tdata[tdata.Date == '1/6/21']
            # cus01.info()
            # cus01.describe()
            cus01 = cus01[['CustomerID', 'InvoiceNo', 'ItemCode', 'QTY.']]
            tdata.shape
            tdata = tdata.loc[tdata['QTY.'] > 0]

            tdata['ItemCode'].sum()
            tdata.describe()
            tdata.shape
            # matrix of items for customers
            customer_item_matrix = tdata.pivot_table(
                index='CustomerID',
                columns='ItemCode',
                values='QTY.',
                aggfunc='sum'
            )

            customer_item_matrix
            customer_item_matrix = customer_item_matrix.applymap(lambda x: 1 if x > 0 else 0)
            customer_item_matrix

            from sklearn.metrics.pairwise import cosine_similarity

            # User-User similarity matrix creating using cosine similarity
            user_user_sim_matrix = pd.DataFrame(
                cosine_similarity(customer_item_matrix)
            )

            user_user_sim_matrix.columns = customer_item_matrix.index
            user_user_sim_matrix['CustomerID'] = customer_item_matrix.index
            user_user_sim_matrix = user_user_sim_matrix.set_index('CustomerID')

            user_user_sim_matrix.loc[1000].sort_values(ascending=False)
            items_bought_by_A = set(customer_item_matrix.loc[1000].iloc[
                                        customer_item_matrix.loc[1000].to_numpy().nonzero()
                                    ].index)

            ccc = len(tdata[tdata['CustomerID'] == customerid])
            if (ccc > 0):
                items_bought_by_B = set(customer_item_matrix.loc[customerid].iloc[
                                            customer_item_matrix.loc[customerid].to_numpy().nonzero()
                                        ].index)

                items_to_recommend_to_B = items_bought_by_A - items_bought_by_B
                Getrecommend = tdata.loc[tdata['ItemCode'].isin(items_to_recommend_to_B), ['ItemCode',
                'ItemName']].drop_duplicates().set_index('ItemCode')

                df = Getrecommend[:10]
                # data = data.to_html()
                json_records = df.reset_index().to_json(orient='records')
                arr = []
                arr = json.loads(json_records)

                print(Getrecommend)

                form = MyForm()
                context = {'ItemRecommend': "Items :  " + Getrecommend ,'form':form , 'Recommended_Products': 'Recommended Products' , 'd': arr}
                return render(request, 'Admin/Item_Recommendation.html', context)
            else:
                form = MyForm()
                context = {'ItemRecommend': "Customer Not Found" ,'form':form}
                return render(request, 'Admin/Item_Recommendation.html', context)

     else:
         form = MyForm()
     return render(request, 'Admin/Item_Recommendation.html', {'form':form});
# end Item Recommendation



# start Demand Prediction
def Demand_Prediction(request):
    inven = pd.read_csv("Data/DataSet.csv", sep=",", encoding="ISO-8859-1", header=0)
    inven.head()
    df_null = round(100 * (inven.isnull().sum()) / len(inven), 2)
    df_null
    rfm_f = inven.groupby('Brand')['OrderAmount'].sum()
    rfm_f = rfm_f.reset_index()
    rfm_f.columns = ['Brand', 'Amont']
    rfm_f.head()
    inven['OrderAmount'].value_counts().head()
    rfm_f
    min_date = min(inven['OrderDate'])
    min_date
    inven['OrderDate'] = pd.to_datetime(inven['OrderDate'], format='%d.%m.%Y')
    min_date = min(inven['OrderDate'])
    min_date
    inven['date'] = min_date - inven['OrderDate']
    inven.head()
    rfm_d = inven.groupby('Brand')['date'].max()
    rfm_d = rfm_d.reset_index()
    rfm_d.columns = ['Brand', 'unpopular']
    rfm_d.head()
    rfm_d['unpopular'] = rfm_d['unpopular'].dt.days
    rfm_d.head()
    rfm_p = pd.merge(rfm_d, rfm_f, on='Brand', how='inner')
    rfm_p.head()
    max_date = max(inven['OrderDate'])
    inven['OrderDate'] = pd.to_datetime(inven['OrderDate'], format='%d.%m.%Y')
    max_date = max(inven['OrderDate'])
    inven['date'] = max_date - inven['OrderDate']
    rfm_m = inven.groupby('Brand')['date'].min()
    rfm_m = rfm_m.reset_index()
    rfm_m.columns = ['Brand', 'popular']
    rfm_m.head()

    rfm_m['popular'] = rfm_m['popular'].dt.days
    rfm_m.head()
    rfm = pd.merge(rfm_p, rfm_m, on='Brand', how='inner')
    rfm.head()

    attributes = ['Amont', 'unpopular', 'popular']
    plt.rcParams['figure.figsize'] = [10, 8]
    sns.boxplot(data=rfm[attributes], orient="v", palette="Set2", whis=1.5, saturation=1, width=0.7)
    plt.title("Outliers Variable Distribution", fontsize=14, fontweight='bold')
    plt.ylabel("Range", fontweight='bold')
    plt.xlabel("Attributes", fontweight='bold')
    Q1 = rfm.Amont.quantile(0.05)
    Q3 = rfm.Amont.quantile(0.95)
    IQR = Q3 - Q1
    rfm = rfm[(rfm.Amont >= Q1 - 1.5 * IQR) & (rfm.Amont <= Q3 + 1.5 * IQR)]

    Q1 = rfm.popular.quantile(0.05)
    Q3 = rfm.popular.quantile(0.95)
    IQR = Q3 - Q1
    rfm = rfm[(rfm.popular >= Q1 - 1.5 * IQR) & (rfm.popular <= Q3 + 1.5 * IQR)]

    Q1 = rfm.unpopular.quantile(0.05)
    Q3 = rfm.unpopular.quantile(0.95)
    IQR = Q3 - Q1
    rfm = rfm[(rfm.unpopular >= Q1 - 1.5 * IQR) & (rfm.unpopular <= Q3 + 1.5 * IQR)]
    rfm_df = rfm[['Amont', 'popular', 'unpopular']]
    scaler = StandardScaler()

    rfm_df_scaled = scaler.fit_transform(rfm_df)
    rfm_df_scaled.shape


    rfm_df_scaled = pd.DataFrame(rfm_df_scaled)
    rfm_df_scaled.columns = ['Amont', 'popular', 'unpopular']
    rfm_df_scaled.head()

    kmeans = KMeans(n_clusters=4, max_iter=50)
    kmeans.fit(rfm_df_scaled)
    kmeans.labels_

    ssd = []
    range_n_clusters = [2, 3, 4, 5, 6, 7, 8]
    for num_clusters in range_n_clusters:
        kmeans = KMeans(n_clusters=num_clusters, max_iter=50)
        kmeans.fit(rfm_df_scaled)

        ssd.append(kmeans.inertia_)

    plt.plot(ssd)

    range_n_clusters = [2, 3, 4, 5, 6, 7, 8]

    kmeans = KMeans(n_clusters=num_clusters, max_iter=50)

    kmeans.fit(rfm_df_scaled)

    cluster_labels = kmeans.labels_
    silhouette_avg = silhouette_score(rfm_df_scaled, cluster_labels)
    print("For n_clusters={0}, the silhouette score is {1}".format(num_clusters, silhouette_avg))

    kmeans = KMeans(n_clusters=4, max_iter=50)
    kmeans.fit(rfm_df_scaled)
    kmeans.labels_


    rfm['Cluster_Id'] = kmeans.labels_
    rfm.head()

    attributes = ['Amont', 'popular', 'unpopular']
    plt.rcParams['figure.figsize'] = [10, 8]
    sns.boxplot(data=rfm[attributes], orient="v", palette="Set2", whis=1.5, saturation=1, width=0.7)
    plt.title("Outliers Variable Distribution", fontsize=14, fontweight='bold')
    plt.ylabel("Range", fontweight='bold')
    plt.xlabel("Attributes", fontweight='bold')


    sns.boxplot(x='Cluster_Id', y='Amont', data=rfm)
    sns.boxplot(x='Cluster_Id', y='popular', data=rfm)
    sns.boxplot(x='Cluster_Id', y='unpopular', data=rfm)
    mergings = linkage(rfm_df_scaled, method="single", metric='euclidean')
    dendrogram(mergings)

    mergings = linkage(rfm_df_scaled, method="complete", metric='euclidean')
    dendrogram(mergings)

    mergings = linkage(rfm_df_scaled, method="average", metric='euclidean')
    dendrogram(mergings)


    cluster_labels = cut_tree(mergings, n_clusters=3).reshape(-1, )
    cluster_labels

    rfm['Cluster_Labels'] = cluster_labels
    labledresult = rfm.replace(to_replace=[0, 1], value=['Popular', 'Unpopular'])
    getfinal = labledresult.head(20)
    print(getfinal)

  #  df = getfinal[:10]
    # data = data.to_html()
    json_records = getfinal.reset_index().to_json(orient='records')
    arr = []
    arr = json.loads(json_records)

    context = {'d': arr}
    return render(request, 'Admin/Demand_Prediction.html',context);
# end Demand Prediction





# end Expiry  Prediction
def Expiry_Prediction(request):
    time = pd.read_csv("Data/DataSet.csv", engine='python' , encoding = 'latin1')

    # formatting the date column correctly
    time.EXPdate = time.EXPdate.apply(lambda x: datetime.datetime.strptime(x, '%d.%m.%Y'))
    # check

    monthly_sales = time.groupby(["Brand", "ItemNo", "OrderAmount",
                                  "OrderDate", "Description", "EXPdate"])



    x = time.groupby(['Brand']).count()
    x = x.sort_values(by='ItemNo', ascending=False)
    x = x.iloc[0:10].reset_index()
    # x
    # #plot
    plt.figure(figsize=(8, 4))
    ax = sns.barplot(x.Brand, x.ItemNo, alpha=0.8)
    plt.title("Items per Category")
    plt.ylabel('# of items', fontsize=12)
    plt.xlabel('Category', fontsize=12)
    # plt.show()
    # In[18]:
    time['EXPdate'] = pd.to_numeric(time['EXPdate'], errors='coerce')

    ts = time.groupby(["ItemNo"])["EXPdate"].sum()
    ts.astype('float')


    def test_stationarity(timeseries):
        # Perform Dickey-Fuller test:
        #  print('Results of Dickey-Fuller Test:')
        dftest = adfuller(timeseries, autolag='AIC')
        dfoutput = pd.Series(dftest[0:4],
                             index=['Test Statistic', 'p-value', '#Lags Used', 'Number of Observations Used'])
        for key, value in dftest[4].items():
            dfoutput['Critical Value (%s)' % key] = value
        #  print(dfoutput)

        test_stationarity(ts)

    from pandas import Series as Series

    # create a differenced series
    def difference(dataset, interval=1):
        diff = list()
        for i in range(interval, len(dataset)):
            value = dataset[i] - dataset[i - interval]
            diff.append(value)
        return Series(diff)

    # invert differenced forecast
    def inverse_difference(last_ob, value):
        return value + last_ob



    def tsplot(y, lags=None, figsize=(10, 8), style='bmh', title=''):
        if not isinstance(y, pd.Series):
            y = pd.Series(y)
        with plt.style.context(style):
            fig = plt.figure(figsize=figsize)
            # mpl.rcParams['font.family'] = 'Ubuntu Mono'
            layout = (3, 2)
            ts_ax = plt.subplot2grid(layout, (0, 0), colspan=2)
            acf_ax = plt.subplot2grid(layout, (1, 0))
            pacf_ax = plt.subplot2grid(layout, (1, 1))
            qq_ax = plt.subplot2grid(layout, (2, 0))
            pp_ax = plt.subplot2grid(layout, (2, 1))

            y.plot(ax=ts_ax)
            ts_ax.set_title(title)
            smt.graphics.plot_acf(y, lags=lags, ax=acf_ax, alpha=0.5)
            smt.graphics.plot_pacf(y, lags=lags, ax=pacf_ax, alpha=0.5)
            sm.qqplot(y, line='s', ax=qq_ax)
            qq_ax.set_title('QQ Plot')
            scs.probplot(y, sparams=(y.mean(), y.std()), plot=pp_ax)

            plt.tight_layout()
        return

    # In[26]:

    # Simulate an AR(1) process with alpha = 0.6
    np.random.seed(1)
    n_samples = int(1000)
    a = 0.6
    x = w = np.random.normal(size=n_samples)

    for t in range(n_samples):
        x[t] = a * x[t - 1] + w[t]
    limit = 12
    _ = tsplot(x, lags=limit, title="AR(1)process")

    # In[27]:

    # Simulate an AR(2) process

    n = int(1000)
    alphas = np.array([.444, .333])
    betas = np.array([0.])

    # Python requires us to specify the zero-lag value which is 1
    # Also note that the alphas for the AR model must be negated
    # We also set the betas for the MA equal to 0 for an AR(p) model
    # For more information see the examples at statsmodels.org
    ar = np.r_[1, -alphas]
    ma = np.r_[1, betas]

    ar2 = smt.arma_generate_sample(ar=ar, ma=ma, nsample=n)
    _ = tsplot(ar2, lags=12, title="AR(2) process")

    # In[28]:

    # Simulate an MA(1) process
    n = int(1000)
    # set the AR(p) alphas equal to 0
    alphas = np.array([0.])
    betas = np.array([0.8])
    # add zero-lag and negate alphas
    ar = np.r_[1, -alphas]
    ma = np.r_[1, betas]
    ma1 = smt.arma_generate_sample(ar=ar, ma=ma, nsample=n)
    limit = 12
    _ = tsplot(ma1, lags=limit, title="MA(1) process")

    # In[29]:

    # Simulate MA(2) process with betas 0.6, 0.4
    n = int(1000)
    alphas = np.array([0.])
    betas = np.array([0.6, 0.4])
    ar = np.r_[1, -alphas]
    ma = np.r_[1, betas]

    ma3 = smt.arma_generate_sample(ar=ar, ma=ma, nsample=n)
    _ = tsplot(ma3, lags=12, title="MA(2) process")

    # In[30]:

    # Simulate an ARMA(2, 2) model with alphas=[0.5,-0.25] and betas=[0.5,-0.3]
    max_lag = 12

    n = int(5000)  # lots of samples to help estimates
    burn = int(n / 10)  # number of samples to discard before fit

    alphas = np.array([0.8, -0.65])
    betas = np.array([0.5, -0.7])
    ar = np.r_[1, -alphas]
    ma = np.r_[1, betas]

    arma22 = smt.arma_generate_sample(ar=ar, ma=ma, nsample=n, burnin=burn)
    _ = tsplot(arma22, lags=max_lag, title="ARMA(2,2) process")

    # In[31]:

    best_aic = np.inf
    best_order = None
    best_mdl = None



    # print('aic: {:6.5f} | order: {}'.format(best_aic, best_order))

    # In[32]:

    #
    # pick best order by aic
    # smallest aic value wins
    best_aic = np.inf
    best_order = None
    best_mdl = None

    rng = range(39)
    for i in rng:
        for j in rng:
            try:
                tmp_mdl = smt.ARMA(new_ts.values, order=(i, j)).fit(method='mle', trend='nc')
                tmp_aic = tmp_mdl.aic
                if tmp_aic < best_aic:
                    best_aic = tmp_aic
                    best_order = (i, j)
                    best_mdl = tmp_mdl
            except:
                continue

    # print('aic: {:6.5f} | order: {}'.format(best_aic, best_order))

    # In[33]:

    ts = time.groupby(["ItemNo"])["EXPdate"].sum()
    finalpt = ts.head(20)

  #  df = getfinal[:10]
    # data = data.to_html()
    json_records = finalpt.reset_index().to_json(orient='records')
    arr = []
    arr = json.loads(json_records)

    context = {'d': arr}
    return render(request, 'Admin/Expiry_Prediction.html',context);

# end Demand Prediction





# start Basket Analysis
def Basket_Analysis(request):
    transData = pd.read_csv('Data/transactionData.csv')
    ass = transData.head()
    # print(ass)

    transData['ITEM NAME'] = transData['ITEM NAME'].str.strip()  # removes spaces from beginning and end
    transData.dropna(axis=0, subset=['Invoice No'], inplace=True)  # removes duplicate invoice
    transData['Invoice No'] = transData['Invoice No'].astype('str')  # converting invoice number to be string
    data = transData[~transData['Invoice No'].str.contains('C')]  # remove the credit transactions
    data.head()

    mybasket = (transData.groupby(['Invoice No', 'ITEM NAME'])['QTY.']
                .sum().unstack().reset_index().fillna(0)
                .set_index('Invoice No'))
    abc = mybasket.head()

    # print(abc)

    # converting all positive values to 1 and everything else to 0
    def my_encode_units(x):
        if x <= 0:
            return 0
        if x >= 1:
            return 1

    my_basket_sets = mybasket.applymap(my_encode_units)
    my_basket_sets

    # TRAINING MODEL
    my_basket_sets = my_basket_sets.replace(np.nan, 0)
    # Generatig frequent itemsets
    my_frequent_itemsets = apriori(my_basket_sets, min_support=0.07, use_colnames=True, verbose=1)
    my_frequent_itemsets

    # generating rules
    my_rules = association_rules(my_frequent_itemsets, metric="lift", min_threshold=1)

    # viewing top 100 rules
  #  my_rules.head(10)


    # Making Recommendations
    # Filtering rules based on condition
    rules = my_rules[(my_rules['lift'] >= 3) & (my_rules['confidence'] >= 0.3)]  # pass to front
    print(rules)  # antecedents # consequents

    finalpt = rules.head(50)

    predata = transData[["Invoice No", "ITEM NAME"]]

    aaaa = (predata['ITEM NAME'].value_counts())  # pass to front

    finalpt2 = aaaa.head(10)

  #  df = getfinal[:10]
    # data = data.to_html()
    json_records = finalpt.reset_index().to_json(orient='records')
    arr = []
    arr = json.loads(json_records)


    json_records2 = finalpt2.reset_index().to_json(orient='records')
    arr2 = []
    arr2 = json.loads(json_records2)
    context = {'d': arr,'d2': arr2}
    return render(request, 'Admin/Basket_Analysis.html',context);
# end Basket Analysis






# start Price Prediction
def Price_prediction(request):
     if request.method == 'POST':
        myForm = MyForm(request.POST)
        if myForm.is_valid():
            inputcode = myForm.cleaned_data['customerid']
            data = pd.read_csv("Data/DataSet.csv", engine='python' , encoding = 'latin1')
            data = data.drop(data.columns[[0, 3, 5, 6, 7]], axis=1)
            data = data.dropna(axis=0, how='any', thresh=None, subset=None, inplace=False)
            datas = data.head()


            data = data[(data["ItemNo"] == inputcode)]

            gethead = data.columns
            # print(gethead)
            x = data[['OrderAmount']]
            y = data['UnitPrice']

            x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.3, random_state=2)
            lm = LinearRegression()
            lm.fit(x_train, y_train)
            coeff_df = pd.DataFrame(lm.coef_, x.columns, columns=['Coefficient'])

            new_input = [[10676]]
            Price_prediction = int(lm.predict(new_input))
            print(Price_prediction)


            form = MyForm()
            context = {'Price_prediction' :   Price_prediction  ,'form':form }
            return render(request, 'Admin/Price_prediction.html', context)

     else:
         form = MyForm()
     return render(request, 'Admin/Price_prediction.html', {'form':form});
# end Price Prediction







# Start Admin Login
def AdminLogin(request):
    if request.method == 'POST':
        myForm = MyForm2(request.POST)
        if myForm.is_valid():
            UserName = myForm.cleaned_data['UserName']
            Password = myForm.cleaned_data['Password']
            gotdata = Umodels.loginDataAdmin.objects.all().filter(UserName=UserName , Password=Password).count()
            if gotdata > 0:
                return render(request, 'Admin/AdminHome.html');
            else:
                messages.success(request, 'Login Info Not Found  , Please Check Your UserName and Password')
                return HttpResponseRedirect(request.path_info)
    else:
        form = MyForm2()
    return render(request, 'Admin/AdminLogin.html', {'form':form});
# End Admin Login

# start Admin Home
def AdminHome(request):
    return render(request,'Admin/AdminHome.html')
# end Admin Home



